import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkVip, ThinkVipParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkVip(params: ThinkVipParam) {
  const res = await request.get<ApiResult<PageResult<ThinkVip>>>(
    THINK_API_URL + '/think/think-vip/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkVip(params?: ThinkVipParam) {
  const res = await request.get<ApiResult<ThinkVip[]>>(
    THINK_API_URL + '/think/think-vip',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkVip(data: ThinkVip) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-vip',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkVip(data: ThinkVip) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-vip',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkVip(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-vip/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkVip(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-vip/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkVip(id: number) {
  const res = await request.get<ApiResult<ThinkVip>>(
    THINK_API_URL + '/think/think-vip/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
